/*********************************************************************

 $Id: TestClient.cxx,v 1.12 2000/05/23 23:47:23 fhong Exp $

 *********************************************************************

  This library is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.  In addition to the
  terms and conditions set forth in the GNU Lesser General Public
  License, as a condition of using this library you are required to
  grant to all users of this library or any implementation utilizing
  or derived from this library a reciprocal, no cost, worldwide,
  perpetual, non-exclusive, non-transferable, unrestricted license to
  your claims of all patents and patent applications throughout the
  world that are infringed by the library or any implementation
  utilizing or derived from this library.  In the event you
  redistribute this library or any implementation utilizing or derived
  from this library, you must prominently display the foregoing terms
  and conditions with the library or the implementation utilizing or
  derived from this library.

  In the event of a conflict of terms between the foregoing license
  grant and the terms set forth in the GNU Lesser General Public
  License, the foregoing terms and conditions shall be deemed to
  govern.

  This library is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not; write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA.

  Copyright 1999-2000 Vovida Networks, Inc.  All Rights Reserved.

 *********************************************************************

 $Log: TestClient.cxx,v $

 *********************************************************************/

#include <sys/time.h>
#include <netinet/in.h>

#include <stdio.h>
#include <unistd.h>
#include <netdb.h>
#include <pwd.h>
#include <stdlib.h>
#include <errno.h>
#include <strings.h>

#include "TestClient.hxx"
#include "VRadiusException.hxx"
#include "cpLog.h"

TestClient* TestClient::_instance = 0;

TestClient::TestClient()
{
}

TestClient&
TestClient::instance(const char *server,
		     const char *secretKey,
		     const int retries)
{
    if(!_instance)
    {
	_instance = new TestClient();

	try
	{
	    _instance->initialize(server,secretKey,retries);
	}
	catch(VRadiusException &e)
	{
	    delete _instance;
	    _instance = 0;
	    throw;
	}
    }
    return *_instance;
}

void
TestClient::destroy()
{
    if(TestClient::_instance)
    {
	delete TestClient::_instance;
	TestClient::_instance = 0;
    }
}

void
TestClient::processVsa(const unsigned char vsaType,
		       unsigned char *ptr,
		       int bufLen)
{
    char logMsg[128];
    string enumStr;
    unsigned short var;
    VsaType atype = (VsaType)vsaType;

    switch(atype)
    {
	case VSA_STATUS:
	    var = *ptr;
	    sprintf(logMsg,"Attribute VSA_STATUS:%d",var);
	    cpLog(LOG_INFO,logMsg);
	    break;

	default:
	    sprintf(logMsg,"Ignored attribute type:%d, length:%d",
		    (int)atype,(int)bufLen);
	    cpLog(LOG_DEBUG,logMsg);
	    break;
    }
}
