/*********************************************************************

 $Id: CommandLine.hxx,v 1.1 2000/05/11 01:47:59 ctam Exp $

 *********************************************************************

  Copyright 1999-2000 Vovida Networks, Inc.  All Rights Reserved.

 *********************************************************************

 $Log: CommandLine.hxx,v $
 Revision 1.1  2000/05/11 01:47:59  ctam
 Creation.

 CommandLine.cxx is used to parse commandline arguments for the applications
 in the softswitch.

 Added Files:    CommandLine.cxx CommandLine.hxx


 ********************************************************************/

#ifndef COMMAND_LINE_H
#define COMMAND_LINE_H

#include <unistd.h>
#include <cstdio>
#include <getopt.h>
#include <cassert>
#include <map.h>
#include "Sptr.hxx"

static const char* const CommandLineVersion = "$Id: CommandLine.hxx,v 1.1 2000/05/11 01:47:59 ctam Exp $";

///
class CommandLine
{
public:

    ///
    static Sptr<CommandLine> instance ( const int argc, 
        const char** argv, 
        const char* applicationUsage = 
                    " [-rd] [-v DEBUG_LEVEL] pserver:port sip-port");


    ///
    static Sptr<CommandLine> instance();
    ///
    const string& getString(const string& cmdLineOption);
    ///
    const int getInt(const string& cmdLineOption);

private:

    CommandLine() {}

    ///
    void setDefaultValues();
    ///
    void parseCommandLine( const int argc, const char**argv );
    ///
    static Sptr<CommandLine> commandLine;
    ///
    typedef map<string, string> Table;
    ///
    typedef Table::iterator     TableIter;
    ///
    static const pair<const char*, const char*> cmdLineOptionString[];
    ///
    Table   cmdLineOptionTable;
    ///static Table   cmdLineOptionTable;
};

#endif

