/*********************************************************************

 $Id: Event.cxx,v 1.1 2000/05/14 17:58:56 icahoon Exp $

 *********************************************************************

  This library is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.  In addition to the
  terms and conditions set forth in the GNU Lesser General Public
  License, as a condition of using this library you are required to
  grant to all users of this library or any implementation utilizing
  or derived from this library a reciprocal, no cost, worldwide,
  perpetual, non-exclusive, non-transferable, unrestricted license to
  your claims of all patents and patent applications throughout the
  world that are infringed by the library or any implementation
  utilizing or derived from this library.  In the event you
  redistribute this library or any implementation utilizing or derived
  from this library, you must prominently display the foregoing terms
  and conditions with the library or the implementation utilizing or
  derived from this library.

  In the event of a conflict of terms between the foregoing license
  grant and the terms set forth in the GNU Lesser General Public
  License, the foregoing terms and conditions shall be deemed to
  govern.

  This library is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not; write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA.

  Copyright 2000 Vovida Networks, Inc.  All Rights Reserved.

 *********************************************************************

 $Log: Event.cxx,v $
 Revision 1.1  2000/05/14 17:58:56  icahoon
 Problem: when using the Event, as a base class for H.323 events, it
 managed to bring in the entire SIP base code. This was an undesired
 result since H.323 should be independent of SIP.

 Solution: Separated freebx/sipProxy/base/Event into two Events, one
 that was SIP independent, being util/Event, and one that was SIP
 dependent, being freebx/sipProxy/base/SipProxyEvent.

 Besides the changes to Event and SipProxyEvent, the remaining changed were
 generally changing the access to the SipProxyEvent via the derived
 class pointer rather than the base event pointer.

 ********************************************************************/

#include "Event.hxx"

Event::Event()
{
}

Event::~Event()
{
}

