/*********************************************************************

 $Id: TcpServerSocket.hxx,v 1.3 2000/05/18 21:24:02 bogawa Exp $

 *********************************************************************

  This library is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.  In addition to the
  terms and conditions set forth in the GNU Lesser General Public
  License, as a condition of using this library you are required to
  grant to all users of this library or any implementation utilizing
  or derived from this library a reciprocal, no cost, worldwide,
  perpetual, non-exclusive, non-transferable, unrestricted license to
  your claims of all patents and patent applications throughout the
  world that are infringed by the library or any implementation
  utilizing or derived from this library.  In the event you
  redistribute this library or any implementation utilizing or derived
  from this library, you must prominently display the foregoing terms
  and conditions with the library or the implementation utilizing or
  derived from this library.

  In the event of a conflict of terms between the foregoing license
  grant and the terms set forth in the GNU Lesser General Public
  License, the foregoing terms and conditions shall be deemed to
  govern.

  This library is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not; write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA.

  Copyright 1999-2000 Vovida Networks, Inc.  All Rights Reserved.

 *********************************************************************

 $Log: TcpServerSocket.hxx,v $
 Revision 1.3  2000/05/18 21:24:02  bogawa
 fixes to allow for dynamic search for provisioning listener

 Revision 1.2  2000/04/05 21:48:25  surendra

 Added option in the Connection class to make it blocking/non-blocking

 Revision 1.1  2000/02/29 05:17:02  surendra

 Moved class from external util to internal util.
 ~

 Revision 1.1  2000/02/22 22:44:32  surendra

 Added generic classes to wrap Server side and client side socket conenctions.

 Revision 1.0  2000/02/17 surendra
     Initial Revision
 *********************************************************************/
#ifndef TcpServerSocket_hxx
#define TcpServerSocket_hxx

#include <sys/socket.h>
#include <netinet/in.h>

//User define class
#include "mstring.hxx"
#include "Connection.hxx"

class VNetworkException;
class TcpServerSocket;

class TcpServerSocket
{
    public:
        TcpServerSocket(int servPort) throw (VNetworkException&);
        TcpServerSocket() throw (VNetworkException&);
        TcpServerSocket(const TcpServerSocket&);

        TcpServerSocket& operator=(TcpServerSocket& other);
        ~TcpServerSocket();
        int accept(Connection& con) throw (VNetworkException&);
        void close();
        inline Connection& getClientConn() { return _clientConn; };
        inline Connection& getServerConn() { return _serverConn; };
    private:
        Connection  _serverConn;
        Connection  _clientConn;
};
#endif
