/*********************************************************************

 $Id: ThreadIf.hxx,v 1.1 2000/05/23 01:34:13 tmaneri Exp $

 *********************************************************************

  Copyright 1999-2000 Vovida Networks, Inc.  All Rights Reserved.

 *********************************************************************

 $Log: ThreadIf.hxx,v $
 Revision 1.1  2000/05/23 01:34:13  tmaneri
 moved agentapi/  agentapimib, common threadIf to vovida/util from sipProxy/base

 Revision 1.9  2000/04/06 03:59:48  rag
  Changed #include < to #include "

 Revision 1.8  2000/03/24 23:36:45  rag
 Added void exit() method to exit the thread

 Revision 1.7  2000/03/09 22:41:02  marcl
 Made Join a virtual function

 Revision 1.6  2000/03/09 03:56:01  rag
 Fixed Id

 Revision 1.5  2000/03/03 05:18:58  rag
 Added ThreadIf::join()

 Revision 1.4  2000/02/26 04:40:45  rag
 Added code for copy ctor and operator=

 Revision 1.3  2000/02/24 02:30:59  rag
 Added const

 Revision 1.2  2000/02/22 20:31:58  rag
 Added copyright header. ~Builder, ~Feature, ~State dtors were changed to clear its list


 ********************************************************************/

#ifndef THREADIF_H
#define THREADIF_H

#include <cassert>
#include "VThread.h"

static const char* const ThreadIfVersion = "$Id: ThreadIf.hxx,v 1.1 2000/05/23 01:34:13 tmaneri Exp $";


class Event;

/** A wrapper class to create and spawn a thread.  It is a base class.
 * ThreadIf::thread() is a pure virtual method
 *
 */

class ThreadIf
{
public:
    ///
    ThreadIf();
    ///
    ThreadIf(const ThreadIf& rhs);
    ///
    ThreadIf& operator=(const ThreadIf& rhs);
    ///
    virtual ~ThreadIf();
    ///
    virtual void run() ;
    ///
    virtual void join()  { itsThread.join(); }

    ///
    virtual void exit()  { itsThread.exit(); }

protected:
    ///
    VThread itsThread;
    ///
    static void* threadWrapper( void* threadParm );
    ///
    virtual void thread() = 0;

private:
    ///
    void copyRhsToThis ( const ThreadIf & rhs );

};


#endif //THREADIF_H
