/*********************************************************************

 $Id: UdpStack.cxx,v 1.60 2000/06/06 20:52:30 chok Exp $

 *********************************************************************

  This library is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.  In addition to the
  terms and conditions set forth in the GNU Lesser General Public
  License, as a condition of using this library you are required to
  grant to all users of this library or any implementation utilizing
  or derived from this library a reciprocal, no cost, worldwide,
  perpetual, non-exclusive, non-transferable, unrestricted license to
  your claims of all patents and patent applications throughout the
  world that are infringed by the library or any implementation
  utilizing or derived from this library.  In the event you
  redistribute this library or any implementation utilizing or derived
  from this library, you must prominently display the foregoing terms
  and conditions with the library or the implementation utilizing or
  derived from this library.

  In the event of a conflict of terms between the foregoing license
  grant and the terms set forth in the GNU Lesser General Public
  License, the foregoing terms and conditions shall be deemed to
  govern.

  This library is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not; write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA.

  Copyright 1999-2000 Vovida Networks, Inc.  All Rights Reserved.

 *********************************************************************

 $Log: UdpStack.cxx,v $
 Revision 1.60  2000/06/06 20:52:30  chok
 Change level from LOG_DEBUG to LOG_DEBUG_STACK

 Revision 1.59  2000/05/25 01:54:47  wenqing
 add comments

 Revision 1.58  2000/05/24 20:32:17  jeff
 fix for the sendonly->sendrecv

 Revision 1.57  2000/05/23 20:48:14  tmaneri

 set sockoption to reuse the address.

 Revision 1.56  2000/05/01 19:16:19  bogawa
 fixes for FreeBSD compiling in util directory

 Revision 1.55  2000/05/01 19:06:14  bogawa
 fixes for FreeBSD compiling in util directory

 Revision 1.54  2000/04/27 01:05:45  wenqing
 fix problem for sendto+recvfrom+connection refused
 It is only happened for linux, not on freeBSD and Solaris

 Revision 1.53  2000/04/03 23:25:31  ctam
 Add rules for vxworks compile.

 NOTE: functions UdpStack::receiveTimeout and Daemon are not compiled
       for vxworks.

 Modified Files:  Daemon.cxx UdpStack.cxx

 Revision 1.52  2000/03/28 22:42:37  rag
 Add receiveTimeout.  a receive call with a timeout based on select.

 Revision 1.51  2000/03/23 23:24:09  wenqing
 Solving mem leak of strstream usage

 Revision 1.50  2000/03/23 00:03:21  jeff
 fixed a compilation error

 Revision 1.49  2000/03/22 23:50:19  jeff
 added support for compilation on Sun Solaris

 Revision 1.48  2000/03/22 23:34:14  jeff
 *** empty log message ***

 Revision 1.47  2000/03/11 02:07:59  jeff
 change getDestinationHost() to return a ptr instead of instance.

 Revision 1.46  2000/03/10 23:03:26  wenqing
 remove the logFlag

 Revision 1.45  2000/02/18 00:17:24  wenqing
 add in something for multicast

 Revision 1.44  2000/02/15 03:43:10  wenqing
 adding files of inject udp pkts from log files.
 update for creating the log files.

 Revision 1.43  2000/02/11 22:13:51  wenqing
 adding handling for creating log files

 Revision 1.42  2000/01/31 20:21:56  wenqing
 update for stack mode and some misc items

 Revision 1.41  2000/01/27 20:58:33  wenqing
 update for modei(recvonly/sendonly/sendrecv) implementation

 Revision 1.40  2000/01/25 21:35:42  wenqing
 add commit for disconnectPorts

 Revision 1.39  2000/01/25 21:28:42  wenqing
 Update for add more checking for different mode(recvonly/sendrecv etc.)
 of the UdpStack.

 Revision 1.38  2000/01/24 23:42:11  wenqing
 update for disconnectPorts

 Revision 1.37  2000/01/24 21:59:51  wenqing
 update comments

 Revision 1.36  2000/01/11 00:56:00  bogawa
 copyright notice fixes for year 2000

 Revision 1.35  2000/01/07 22:21:40  wenqing
 Rename interface since it is reserved word for WIN32

 Revision 1.34  1999/12/24 03:27:56  wenqing
 update

 Revision 1.33  1999/12/24 03:08:18  tina
 rm #ifdef vxworks for making it to the OS independency.

 Revision 1.32  1999/12/24 00:33:04  wenqing
 fix for the problem of send/sento with using of connect()

 Revision 1.31  1999/12/23 20:34:06  wenqing
 name change for vtime

 Revision 1.30  1999/12/22 01:37:23  wenqing
 add mode(recvonly, sendonly, sendrecv) to UdpStack

 Revision 1.29  1999/12/21 21:51:46  bogawa
 fixes for the great renaming

 Revision 1.28  1999/12/18 04:28:48  eckelcu
 Modified Files:
 	networkAddress.cxx udp.cxx test/VThreadTest.cxx
 	test/udpTest/Makefile test/udpTest/test_udp.cxx
 Changes for udp to work for vxworks

 Revision 1.27  1999/12/17 01:30:28  wenqing
 bug fixes

 Revision 1.26  1999/12/16 20:32:20  wenqing
 fix up some bugs while write test programs

 Revision 1.25  1999/12/05 05:14:44  cullen
 fixed network byte order stuff

 Revision 1.24  1999/11/30 02:09:31  eckelcu
 Modified Files:
 	Data.cxx Data.hxx DataBuff.cxx DataBuff.hxx cpLog.cxx
 	debug.cxx fifo.cxx parse3tuple.cxx parse3tupleTest.cxx
 	sptr.hxx support.cxx support.hxx timer.cxx udp.cxx udp.hxx
 	udpTransport.cxx udpTransport.hxx vcondition-linux.cxx
 	vcondition-vxworks.cxx vmutex-linux.cxx vmutex-vxworks.cxx
 	vthread-linux.cxx vthread-vxworks.cxx vtime-vxworks.cxx
 Added consistent cvs header and LGPL license info to all files in /util

 Revision 1.23  1999/11/30 01:25:05  wenqing
 comments change

 Revision 1.22  1999/11/30 01:21:15  wenqing
 change xAddress(rxAddress and txAddress) to localAddr and remoteAddr.
 Add localPort and remotePort
 
 Revision 1.21  1999/11/25 01:47:27  eckelcu
 Modified Files:
 	Makefile fifo.cxx fifo.h udp.cxx vcondition.h vmutex.h
 	vthread-vxworks.cxx vthread.h VTime.hxx
 Added Files:
 	vtime-vxworks.cxx
 Removed Files:
 	vos.h
 Added additional functionality to OS abstraction for sleep() and
 gettimeofday(). Modified fifo and udp so they compile for vxworks. Moved
 definitions in vos.h to vthread.h.

 Revision 1.20  1999/11/25 00:36:37  wenqing
 add definitions for vxworks.

 Revision 1.19  1999/11/23 02:12:05  wenqing
 changes for porting to sh-vxworks

 Revision 1.18  1999/11/19 01:39:56  bogawa
 fixes and changes for building the SH targets successfully

 Revision 1.17  1999/11/19 00:38:00  bogawa
 changes for the util directory as well as using the new vmutex, etc. classes

 Revision 1.16  1999/11/18 01:42:45  wenqing
 fix compiling error, very minor change.

 Revision 1.15  1999/11/18 00:32:35  wenqing
 Remove UdpPacket classes, and UdpErrorType enum. App can use Data class and
 UdpException class instead.

 Revision 1.14  1999/11/17 22:52:38  wenqing
 use cpLog instead of cerr

 Revision 1.13  1999/11/16 02:54:38  wenqing
 bug fixes

 Revision 1.12  1999/11/12 21:47:09  wenqing
 more changes according to cullen's change in networkAddress class

 Revision 1.11  1999/11/12 03:09:56  wenqing
 More complete update version. They are compiled.

 Revision 1.10  1999/11/11 02:58:00  wenqing
 This is a new and temp version of udp.cxx.
 New interfaces are added and it should be a unified version for all
 applications. (not compilable!!!)

 Revision 1.9  1999/10/25 22:02:20  bogawa
 merge from irix6-0914 back into the main branch

 Revision 1.8  1999/10/08 20:32:26  devel
 changes for compiling on SGI.

 Revision 1.7  1999/09/22 07:37:59  bogawa
 fixes for VON conference

 Revision 1.6.4.2  1999/10/03 23:34:33  devel
 fixes for older IRIX boxes

 Revision 1.6.4.1  1999/09/15 00:24:21  bogawa
 merge in cheung's changes and changes to compile under sgi

 Revision 1.6  1999/08/17 21:03:45  kle
 Authours: Cullen Jennings, Kim Le, Bryan Ogawa
 Improvements on the jitter buffer.
 Flexability for 20ms on the wire.
 Added usage for Cullen's UDP code.
 Added usage for Chok's cpLog code.
  
 ********************************************************************/

/* TODO List 
 * - add sendTo function to allow you to specifiy different destinations
 * - add recvFrom function that tell you who the packet came from 
 * - add non blockinge version fo send and receive
 * - derive "ReliableUDP" stack that takes care of retransmissions
 * - look into using MSG_ERRQUEUE to check for ICMP errors
 * - check portability 
 * - support IP6 
 * - stress test 
 */

#include <fstream>
#include <assert.h>
#include <string.h> // for memset 
#include <errno.h>
#include <iostream>
#include <stdio.h>
#include <netdb.h>
#if defined(__FreeBSD__)
#include <sys/types.h>
#endif
#include <netinet/in.h> // for struct sockaddr_in
#include <stdlib.h>
#include <strstream>
#include <sys/types.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#include "VTime.hxx"
#include <unistd.h>

#ifndef __vxworks
#include <fcntl.h>
#endif

#include "vovida-endian.h"

#if defined(__svr4__)
typedef int socklen_t;
#endif

#include "UdpStack.hxx"
#include "cpLog.h"
#include "vsock.hxx"

// this class hold stuff that is likely to be a problem to port 
class UdpStackPrivateData
{
public:
    /// File descriptor of socket 
    int socketFd;
      
    /// Address of local computer that will receive or send the packets 
    struct sockaddr_in localAddr;
      
    /// Address of remote computer that local computer receive from 
    /// or send to the packets 
    /// This address is set when doClient is called.
    /// And later when setDestination() is called, this address will be the one 
    /// connect to. But disconnectPorts() won't remove this address.
    struct sockaddr_in remoteAddr;
      
};

static const char separator[7] = "\n****\n";

UdpStack::UdpStack ( const NetworkAddress* desHost 
                         /* null if this is the server */ ,
		     int minPort,
                     int maxPort,
                     UdpMode udpMode,
                     bool log_flag )
    : localPort(-1),
      remotePort(-1),
      packetLossProbability( float(0.0) ),
      numBytesReceived (0),
      numPacketsReceived (0),
      numBytesTransmitted (0),
      numPacketsTransmitted (0),
      mode (sendrecv),
      logFlag (log_flag)
{
    data = new UdpStackPrivateData;
    assert(data);

    mode = udpMode;

    // open a socket 
    data->socketFd = socket(PF_INET, SOCK_DGRAM, IPPROTO_UDP);
    cpLog (LOG_DEBUG_STACK, "UdpStack socketFd = %d", data->socketFd);
    if ( data->socketFd < 0  )
    {
        int err = errno;
        strstream errMsg;
        errMsg << "UdpStack<" /* << getLclName() */
	       << ">::UdpStack error during socket creation: ";
        errMsg << strerror(err);
        errMsg << char(0);
      
        clog << errMsg.str() << endl;
        throw UdpStackException(errMsg.str());
        errMsg.freeze(false);
        assert(0);
    }
  
#ifdef __linux__
    int buf1 = 1;
    int len1 = sizeof(buf1);
    struct protoent * protoent;
    protoent =  getprotobyname("icmp");

    if (!protoent)
    {
        fprintf(stderr, "Cannot get icmp protocol\n");
    }
    else
    {
        if (setsockopt(data->socketFd, protoent->p_proto, SO_BSDCOMPAT,
                       (char*)&buf1, len1)
            == -1)
        {
            fprintf(stderr, "setsockopt error SO_BSDCOMPAT :%s",
                    strerror(errno));
        }
    }
#endif
 
    // set option to get rid of the "Address already in use" error
    if (setsockopt(data->socketFd, SOL_SOCKET, SO_REUSEADDR,
		   (char*)&buf1, len1)
	== -1)
        {
            fprintf(stderr, "setsockopt error SO_REUSEADDR :%s",
                    strerror(errno));
        }
    
    // set up addresses 
    memset((char*) &(data->localAddr),0, sizeof((data->localAddr)));
    (data->localAddr).sin_family = AF_INET;
    (data->localAddr).sin_addr.s_addr = htonl(INADDR_ANY);

    memset((char*) &(data->remoteAddr),0, sizeof((data->remoteAddr)));
    (data->remoteAddr).sin_family = AF_INET;
    (data->remoteAddr).sin_addr.s_addr = htonl(INADDR_ANY);

    switch (mode)
    {
        case inactive :
        {
            cpLog(LOG_INFO, "Udp stack is inactive");
            cpLog(LOG_ERR, "desHost is saved for future use.");
            doClient(desHost, desHost->getPort());
        }
            break;
        case sendonly :
        {
            if ( desHost )
            {
                // set the remote address
                doClient(desHost, desHost->getPort());
            }
            else
            {
                cpLog(LOG_INFO, 
            "sendonly Udp stack, desHost is needed by using setDestination()");
            }
        }
            break;
        case recvonly :
        {
            if ( desHost )
            {
                cpLog(LOG_ERR, 
                "recvonly Udp stack, desHost is saved for future use.");
                doClient(desHost, desHost->getPort());
            }
            else
            {
                // only receive, do bind socket to local port
                doServer(minPort, maxPort);
            }
        }
            break;
        case sendrecv :
        {
            if ( desHost )
            {
                // receive and send, 
                // bind the socket to local port and set the remote address
                doServer(minPort, maxPort); 
                doClient(desHost, desHost->getPort());
            }
            else
            {
                // only receive, do bind socket to local port
                doServer(minPort, maxPort); 
                cpLog(LOG_INFO, 
            "sendrecv Udp stack, desHost is needed by using setDestination()");
            }
        }
            break;
        default :
            cpLog(LOG_ERR, "undefined mode for udp stack");
            break;
    }

//    logFlag = true;

    strstream logFileNameRcv;
    strstream logFileNameSnd;

    logFileNameRcv << "udpRcv" << "-"
	           << data->socketFd << "-"
                   << localPort << ".log" 
	           << char(0);
    
    logFileNameSnd << "udpSnd" << "-"
	           << data->socketFd << "-"
                   << localPort << ".log" 
	           << char(0);
    

    if (logFlag)
    {
        in_log = new ofstream(logFileNameRcv.str(), ios::app);
        if (!in_log) 
        {
            cerr << "Cannot open file " 
                 << logFileNameRcv.str() << endl;
            logFileNameRcv.freeze(false);
            logFlag = false;
        }
        else
        {
            in_log->write ("UdpRcv\n", 7);
            strstream lcPort;
            lcPort << "localPort: " << localPort << "\n" << char(0);
            in_log->write(lcPort.str(), strlen(lcPort.str()));
            lcPort.freeze(false);
            logFileNameRcv.freeze(false);
            rcvCount = 0;
        }

        out_log = new ofstream(logFileNameSnd.str(), ios::app);
        if (!out_log) 
        {
            cerr << "Cannot open file "
                 << logFileNameSnd.str() << endl;
            logFileNameSnd.freeze(false);
            logFlag = false;
        }
        else
        {
            if (! logFlag)
                logFlag = true;
            out_log->write ("UdpSnd\n", 7);
            logFileNameSnd.freeze(false);
            sndCount = 0;
        }
    }
       
}

void
UdpStack::doServer ( int minPort,
                     int maxPort )  // these are lcoal ports
{
/*
    cpLog (LOG_DEBUG_STACK, "UdpStack::doServer");
    cpLog (LOG_DEBUG_STACK, "minPort = %d, maxPort = %d", minPort, maxPort);
*/

    // this is a server 
    if ( (minPort==-1) && (maxPort==-1) )
    {
        minPort = 1025;
	maxPort = 65534;
    }
    if ( maxPort == -1 )
    {
	maxPort = minPort;
    }

    // reset name now that the port range is defined
    strstream aName;
    aName << "-receiver-" << ":" 
	  << "[" << minPort 
	  << "-" << maxPort << "]" 
	  << char(0);
    setLclName( aName.str() );
    aName.freeze(false);
      
    // find a port to use 
    int portOk = false;
    int err = 0;
    // here it assigns the port, the local port
    // & bind the addr(INADDR_ANY+port) to the socket
    for( localPort = minPort; localPort <= maxPort; localPort++ )
    {
	(data->localAddr).sin_port = htons(localPort);

        cpLog(LOG_DEBUG_STACK, "Udp bind() fd = %d, port = %d(h_order), %d(n_order)",
              data->socketFd, localPort, (data->localAddr).sin_port);

	if ( bind( data->socketFd, 
		   (struct sockaddr*) &(data->localAddr),
		   sizeof((data->localAddr)))
	     != 0 )
	{
	    err = errno;
	    if ( err == EADDRINUSE )
	    {
		continue; // this port is in use - try the next one 
	    }
	    
	    int err = errno;
	    strstream errMsg;
	    errMsg << "UdpStack<" << getLclName() 
		   << ">::UdpStack error during socket bind: ";
	    errMsg << strerror(err);
	    errMsg << char(0);
	    
	    clog << errMsg.str() << endl;
	    throw UdpStackException(errMsg.str());
            errMsg.freeze(false);
	    assert(0);
	}
	else
	{
	    portOk=true;
	    break;
	}
    }
      
    // deal with errors
    if (!portOk)
    {
	// all ports are in use
	localPort = -1;
	strstream errMsg;
	errMsg << "UdpStack<" << getLclName() 
	       << ">::UdpStack all ports in range "
	       << minPort << " to " << maxPort
	       << " are in use.";
	errMsg << char(0);
	clog << errMsg.str() << endl;
	throw UdpStackExceptionPortsInUse(errMsg.str());
        errMsg.freeze(false);
	assert(0);
    }

    // reset name now that the port is defined
    strstream aName2;
    aName2 << "-receiver-" << ":" << minPort << char(0);
    setLclName( aName2.str() );
    aName2.freeze(false);
}

void 
UdpStack::doClient ( const NetworkAddress* desHost,
		     int desPort ) // This is the destination port
{
/*
    cpLog (LOG_DEBUG_STACK, "UdpStack::doClient");
    cpLog (LOG_DEBUG_STACK, "desHost = %s, desPort = %d", 
           desHost->getIpName().c_str(), desPort);
*/

    // this is a client
    assert (desHost);
    // build a name 
    strstream aName;
    aName << (desHost->getIpName()).c_str() << ":" << desPort << char(0);
    setRmtName( aName.str() );
    aName.freeze(false);

    
    // find the host 
    struct hostent* host = gethostbyname ((desHost->getIpName()).c_str());

    if (host == NULL)
    {
	int err = h_errno;

	strstream errMsg;
	errMsg << "UdpStack<" << getRmtName() << ">::UdpStack  ";
	 
	switch (err)
	{
	case HOST_NOT_FOUND:
	{
	    errMsg << "unknown hostname <" 
                   << (desHost->getIpName()).c_str() 
                   << "> ";
	    //errMsg << hstrerror(err);
	}
	break;
	case NO_ADDRESS:
	{
	    errMsg << " hostname <" 
                   << (desHost->getIpName()).c_str() 
                   << "> has no IP address";
	    //errMsg << hstrerror(err);
	}
	break;
	case NO_RECOVERY:
	{
	    errMsg << " problem with nameserver while looking hostname <" 
                   << (desHost->getIpName()).c_str() 
                   << "> ";
	    //errMsg << hstrerror(err);
	}
	break;
	case TRY_AGAIN:
	{
	    errMsg << " problem with nameserver while looking hostname <" 
		   << (desHost->getIpName()).c_str() 
                   << "> - try again ";
	    //errMsg << hstrerror(err);
	}
	break;
	default:
	{
	    errMsg << "Can't lookup hostname <" 
                   << (desHost->getIpName()).c_str() 
                   << "> ";
	    errMsg << " errno=" << err << " ";
	    //errMsg << hstrerror(err);
	}
	break;
	}
	 
	errMsg << char(0);
	clog << errMsg.str() << endl;
	throw UdpStackExceptionBadHostname(errMsg.str());
        errMsg.freeze(false);
	assert(0);
    }

    // set host data in structure 
    // this is the destination address
    assert( host->h_addr_list[0] );
    memcpy((char*)&(data->remoteAddr).sin_addr.s_addr,
	   host->h_addr_list[0], // take the first entry 
	   host->h_length);

    // set up the port data 
    // this is the destination port,
    // The addr above plus the port is the only addr from which 
    // the data will received
    remotePort = desPort;      
    assert( remotePort != 0 ); // can't have unknown port on client end 
    assert( remotePort > 1024 ); 
    assert( remotePort < 65000 );
    (data->remoteAddr).sin_port = htons(remotePort);

}

void
UdpStack::connectPorts()
{
    if ((mode == recvonly) || (mode == inactive))
    {
        cpLog(LOG_ERR, "The UdpStack is recvonly or inactive.");
        return;
    }

    int result;

    // conenct to server 
    if ((result=connect(data->socketFd,
		(struct sockaddr*)  &(data->remoteAddr),
		sizeof(data->remoteAddr))) != 0)
    {
	int err = errno;
	strstream errMsg;
	errMsg << "UdpStack<" << getLclName() << " " << getRmtName()
	       << ">::UdpStack error during socket connect: ";
	errMsg << strerror(err);
	errMsg << char(0);
      
	clog << errMsg.str() << endl;
	throw UdpStackException(errMsg.str());
        errMsg.freeze(false);
	assert(0);
    }
//    cout << result;
}


// After testing, this method currently is not working on Linux and Sun4
// possibily because the system are not supporting it.
// Now the work around is to call connect twice.
void
UdpStack::disconnectPorts()
{
    if ((mode == recvonly) || (mode == inactive))
    {
        cpLog(LOG_ERR, "The UdpStack is recvonly or inactive.");
        return;
    }

    struct sockaddr dummyAddr;

    memset((char*) &dummyAddr,0, sizeof(dummyAddr));
    dummyAddr.sa_family = AF_INET;

    int result;
//    cerr << "test1 " << endl;

    if ((result=connect(data->socketFd,
		(struct sockaddr*)  &dummyAddr,
		sizeof(dummyAddr))) != 0)
    {
	int err = errno;
	strstream errMsg;
	errMsg << "UdpStack<" << getLclName() << " " << getRmtName()
	       << ">::UdpStack error during socket connect: ";
	errMsg << strerror(err);
	errMsg << char(0);
      
	clog << errMsg.str() << endl;
        errMsg.freeze(false);
#if 0
	throw UdpStackException(errMsg.str());
	assert(0);
#endif
    }
//    cerr << result;

    dummyAddr.sa_family = AF_UNSPEC;
    if ((result=connect(data->socketFd,
		(struct sockaddr*)  &dummyAddr,
		sizeof(dummyAddr))) != 0)
    {
	int err = errno;
	strstream errMsg;
	errMsg << "UdpStack<" << getLclName() << " " << getRmtName()
	       << ">::UdpStack error during socket connect: ";
	errMsg << strerror(err);
	errMsg << char(0);
      
	clog << errMsg.str() << endl;
        errMsg.freeze(false);
#if 0
	throw UdpStackException(errMsg.str());
	assert(0);
#endif
    }
}

/// set the local ports
/// The first time change from inactive to recvonly/sendrecv or
/// change the local ports, this method needs to be called.
void
UdpStack::setLocal (const int minPort, int maxPort )
{
    cpLog (LOG_DEBUG_STACK, "UdpStack::setLocal");
    cpLog (LOG_DEBUG_STACK, "minPort = %d, maxPort = %d", minPort, maxPort);

    if ((mode == sendonly) || (mode == inactive))
    {
        cpLog(LOG_ERR, "The UdpStack is sendonly or inactive.");
        return;
    }
// To reopen a new socket, since after sendto(), bind() will fail
//    if (localPort != -1) 
    {
        close (data->socketFd);
        data->socketFd = socket(PF_INET, SOCK_DGRAM, IPPROTO_UDP);
        if ( data->socketFd < 0  )
        {
            int err = errno;
            strstream errMsg;
            errMsg << "UdpStack<" /* << getLclName() */
                   << ">::UdpStack error during socket creation: ";
            errMsg << strerror(err);
            errMsg << char(0);

            clog << errMsg.str() << endl;
            throw UdpStackException(errMsg.str());
            errMsg.freeze(false);
            assert(0);
        }
#ifdef __linux__
        int buf1 = 1;
        int len1 = sizeof(buf1);
        struct protoent * protoent;
        protoent =  getprotobyname("icmp");

        if (!protoent)
        {
            fprintf(stderr, "Cannot get icmp protocol\n");
        }
        else
        {
            if (setsockopt(data->socketFd, protoent->p_proto, SO_BSDCOMPAT,
                           (char*)&buf1, len1)
                == -1)
            {
                fprintf(stderr, "setsockopt error SO_BSDCOMPAT :%s",
                        strerror(errno));
            }
        }
#endif


    }
    doServer(minPort, maxPort);
}

/// set the default destination
void
UdpStack::setDestination ( const NetworkAddress* host )
{
    if ((mode == recvonly) || (mode == inactive))
    {
        cpLog(LOG_ERR, "The UdpStack is recvonly or inactive.");
        return;
    }
    doClient(host, host->getPort());
}

void
UdpStack::setDestination ( const char* host, int port )
{
    NetworkAddress* netAddressPtr = 0;

    if ( host )
    {
        string rHostName = host;
        NetworkAddress netAddress(port);
        netAddressPtr = &netAddress;
        netAddressPtr->setHostName(rHostName);
    }

    setDestination (netAddressPtr);
}

/// need to delete the ne wobject after the object is used
NetworkAddress *
UdpStack::getDestinationHost () const
{

    NetworkAddress* desHost = new NetworkAddress() ;

    desHost->setPort(remotePort);
    desHost->setHostName(inet_ntoa((data->remoteAddr).sin_addr)); 

    return desHost;
    
}


int  
UdpStack::getSocketFD ()
{
    assert(data);
    return data->socketFd;
}

void
UdpStack::addToFdSet ( fd_set* set )
{
    assert(set);
    FD_SET(data->socketFd, set);
}      


int  
UdpStack::getMaxFD ( int prevMax )
{
    return ( getSocketFD() > prevMax ) ? getSocketFD() : prevMax;
}


bool
UdpStack::checkIfSet ( fd_set* set )
{
    assert(set);
    return static_cast<bool> FD_ISSET(data->socketFd, set);
}


int
UdpStack::receive ( const char* buf, const int bufSize )
{
    if ((mode == sendonly) || (mode == inactive))
    {
        cpLog(LOG_ERR, "The stack is not capable to receive. ");
        return -1;
    }

    int len = recv( data->socketFd, 
		    (char *)buf,bufSize,
		    0 /*flags */);
    if ( len <= 0 )
    {
        int err = errno;
        strstream errMsg;
        errMsg << "UdpStack<" << getLclName() 
	       << ">::receive error : ";
        errMsg << strerror(err);
        errMsg << char(0);
      
        clog << errMsg.str() << endl;
        errMsg.freeze(false);
#if 0
        throw UdpStackException(errMsg.str());
        assert(0);
#endif
//        cpLog(LOG_DEBUG_STACK, "UdpStack::receive pkt len=0");
    }
    else
    {
        numBytesReceived += len;
        numPacketsReceived += 1;
    }
   
    if ( (logFlag) && (len > 0) )
    {
        strstream lenln1;
        lenln1 << ++rcvCount << " " << len << "\n" << char(0);
        in_log->write(lenln1.str(), strlen(lenln1.str()));
        in_log->write(buf, len);
        in_log->write(separator, 6);
        lenln1.freeze(false);
    }

    return len;
}


int  
UdpStack::receiveFrom ( const char* buffer,
                        const int bufSize,
                        NetworkAddress* sender ) // returns bytes read
{
    if ((mode == sendonly) || (mode == inactive))
    {
        cpLog(LOG_ERR, "The stack is not capable to receive. ");
        return -1;
    }

    string hostname;
    struct sockaddr_in xSrc;
    unsigned int lenSrc=sizeof(xSrc);

    int len = recvfrom( data->socketFd, 
		        (char *)buffer,
                        bufSize,
		        0 /*flags */ , 
                        (struct sockaddr*)&xSrc,
                        (socklen_t *) &lenSrc);
    
    if ( len <= 0 )
    {
        int err = errno;
        strstream errMsg;
        errMsg << "UdpStack<" << getLclName() 
	       << ">::receive error : ";
        errMsg << strerror(err);
        errMsg << char(0);
      
        clog << errMsg.str() << endl;
        errMsg.freeze(false);
#if 0
        throw UdpStackException(errMsg.str());
        assert(0);
#endif
    }
    else
    {
        hostname = inet_ntoa(xSrc.sin_addr);

        sender->setPort(ntohs(xSrc.sin_port));
        sender->setHostName(hostname);

//  cout << "UDP receive from" << sender;
    
        numBytesReceived += len;
        numPacketsReceived += 1;
    }
   
    if ( (logFlag) && (len > 0) )
    {
        strstream lenln2;
        lenln2 << ++rcvCount << " " << len << "\n" << char(0);
        in_log->write(lenln2.str(), strlen(lenln2.str()));
        in_log->write(buffer, len);
        in_log->write(separator, 6);
        lenln2.freeze(false);
    }

    return len;
}

int
UdpStack::receiveTimeout ( const char* buffer,
			 const int bufSize,
			 NetworkAddress* sender,
			 int sec, 
			 int usec)
{
#ifndef __vxworks
    timeval tv;
    fd_set rset;
    int fd = getSocketFD();
    int flags, retVal;

    // set socket to non-blocking then return it back after receive call
    if ((flags = fcntl(fd, F_GETFL, 0)) < 0)
	return -1;
    flags |= O_NONBLOCK;
    if (fcntl(fd, F_SETFL, flags) < 0)
	return -1;

    // select will return upon timeout, error or received message
    FD_ZERO(&rset);
    FD_SET(fd, &rset);
    tv.tv_sec = sec;
    tv.tv_usec = usec;
    retVal = select(fd + 1, &rset, NULL, NULL, &tv);
    if (!retVal)
	return retVal;

    retVal =  receiveFrom( buffer,
			   bufSize,
			   sender);

    flags &= ~O_NONBLOCK;
    if (fcntl (fd, F_SETFL, flags) < 0)
	return -1;

    return retVal;
#else

    cpLog(LOG_ERR, "UdpStack::receiveTimeout  * not defined in vxworks *\n");
    return -1;
#endif
}   

// uses send() which is better to get ICMP msg back
void 
UdpStack::transmit ( const char* buf, const int length )
{
    if ((mode == recvonly) || (mode == inactive))
    {
        cpLog(LOG_ERR, "The stack is not capable to transmit. ");
        return ;
    }

    assert(buf);
    assert(length>0);

    if ( packetLossProbability > 0.0 )
    {
        static bool randInit=false;
        if (!randInit)
        {
	    randInit=true;

	    timeval tv;
	    gettimeofday(&tv,NULL);
	 
	    long seed = tv.tv_sec + tv.tv_usec;
	 
	    srandom(seed);
        }
      
        double numerator( random() & 0x7FFFFFFF );
        double denominator(          0x7FFFFFFF );
        double prob = numerator/denominator;
        if ( prob < packetLossProbability )
        {
	    // ok - just drop this packet 
	    return;
        }
    }
   
    int count = send( data->socketFd, 
		      (char *)buf,length,
		      0 /* flags */ );

    if ( count < 0 )
    {
        int err = errno;
        strstream errMsg;
        errMsg << "UdpStack<" << getRmtName() << ">::transmit ";
      
        switch (err)
        {
	    case ECONNREFUSED:
	    {
	        // This is the most common error - you get it if the host
	        // does not exist or is nor running a program to recevice 
	        // the packets. This is what you get with the other side
	        // crashes.

	        errMsg << "Connection refused by destination host";
	        errMsg << char(0);
      	        clog << errMsg.str() << endl;
#if 0
	        throw UdpStackExceptionConectionRefused(errMsg.str());
#endif
	    }
	    break;
	    case EHOSTDOWN:
	    {
	        errMsg << "destination host is down";
	        errMsg << char(0);
      	        clog << errMsg.str() << endl;
	    }
	    break;
	    case EHOSTUNREACH:
	    {
	        errMsg << "no route to to destination host";
	        errMsg << char(0);
      	        clog << errMsg.str() << endl;
	    }
	    break;
	    default:
	    {
	        errMsg << ": " << strerror(err);
	        errMsg << char(0);
      	        clog << errMsg.str() << endl;
                cpLog (LOG_ERR, "UDP sending error: ");
	    }
        }


        errMsg.freeze(false);
#if 0
        throw UdpStackException(errMsg.str());
        assert(0);
#endif
    }
    else if ( count != length )
    {
/*
        int err = errno;
*/
        strstream errMsg;
        errMsg << "UdpStack<" << getRmtName() 
	       << ">:transmit error is send: "
	       << "Asked to transmit " << length
	       << " bytes but only sent " << count ;
        errMsg << char(0);
      
        clog << errMsg.str() << endl;
        errMsg.freeze(false);
#if 0
        throw UdpStackException(errMsg.str());
        assert(0);
#endif
    }
    else
    { 
        numBytesTransmitted += count;
        numPacketsTransmitted += 1;
    }


    if ( (logFlag) && (count > 0) )
    {
        strstream lenln3;
        lenln3 << ++sndCount << " " << count << char(0);
        out_log->write(lenln3.str(), strlen(lenln3.str()));
        lenln3.freeze(false);

        strstream rAddress1;
        rAddress1 << " " << getRmtName() << "\n" << char(0);
        out_log->write(rAddress1.str(), strlen(rAddress1.str()));
        rAddress1.freeze(false);

        out_log->write(buf, count);
        out_log->write(separator, 6);
    }

}


void 
UdpStack::transmitTo ( const char* buffer,
                       const int length,
                       const NetworkAddress* dest )
{

    if ((mode == recvonly) || (mode == inactive))
    {
        cpLog(LOG_ERR, "The stack is not capable to transmit. ");
        return ;
    }

    assert(buffer);
    assert(length>0);

//cout << *dest;
    setDestination(dest);

    struct sockaddr_in xDest;
    xDest.sin_family=AF_INET;
//    xDest.sin_port=htons(dest.getPort());
    xDest.sin_port=htons(dest->getPort());
//    xDest.sin_addr.s_addr=dest.getIp4Address();
    xDest.sin_addr.s_addr=dest->getIp4Address();

    int count = sendto( data->socketFd, 
		        (char*)buffer,
                        length,
		        0 , // flags 
                        (struct sockaddr*)&xDest,
                        sizeof(sockaddr_in));
    if ( count < 0 )
    {
        int err = errno;
        strstream errMsg;
        errMsg << "UdpStack<" << getRmtName() << ">::transmit ";
      
        switch (err)
        {
	    case ECONNREFUSED:
	    {
	        // This is the most common error - you get it if the host
	        // does not exist or is nor running a program to recevice 
	        // the packets. This is what you get with the other side
	        // crashes.

	        errMsg << "Connection refused by destination host";
	        errMsg << char(0);
      	        clog << errMsg.str() << endl;
#if 0
	        throw UdpStackExceptionConectionRefused(errMsg.str());
#endif
	    }
	    break;
	    case EHOSTDOWN:
	    {
	        errMsg << "destination host is down";
	        errMsg << char(0);
      	        clog << errMsg.str() << endl;
	    }
	    break;
	    case EHOSTUNREACH:
	    {
	        errMsg << "no route to to destination host";
	        errMsg << char(0);
      	        clog << errMsg.str() << endl;
	    }
	    break;
	    default:
	    {
	        errMsg << ": " << strerror(err);
	        errMsg << char(0);
      	        clog << errMsg.str() << endl;
	    }
        }

        cpLog (LOG_ERR, "RTP: UDP error: ");

//        cerr << "RTP: UDP error: " << endl;


        errMsg.freeze(false);
#if 0
        throw UdpStackException(errMsg.str());
        assert(0);
#endif
    }
    else if ( count != length )
    {

//        int err = errno;

        strstream errMsg;
        errMsg << "UdpStack<" << getRmtName() 
	       << ">:transmit error is send: "
	       << "Asked to transmit " << length
	       << " bytes but only sent " << count ;
        errMsg << char(0);
      
        clog << errMsg.str() << endl;
        errMsg.freeze(false);
#if 0
        throw UdpStackException(errMsg.str());
        assert(0);
#endif
    }
    else
    { 
        numBytesTransmitted += count;
        numPacketsTransmitted += 1;
    }

    if ( (logFlag) && (count > 0) )
    {
        strstream lenln4;
        lenln4 << ++sndCount << " " << count << char(0);
        out_log->write(lenln4.str(), strlen(lenln4.str()));
        lenln4.freeze(false);

        strstream rAddress2;
        rAddress2 << " " << getRmtName() << "\n" << char(0);
        out_log->write(rAddress2.str(), strlen(rAddress2.str()));
        rAddress2.freeze(false);

        out_log->write(buffer, count);
        out_log->write(separator, 6);
    }


}


///
void 
UdpStack::joinMulticastGroup ( NetworkAddress group,
                               NetworkAddress* iface,
                               int ifaceInexe )
{
#if defined(__linux__)
    struct ip_mreqn mreqn;
    mreqn.imr_multiaddr.s_addr=(group.getIp4Address());

    mreqn.imr_address.s_addr=(iface->getIp4Address());
    mreqn.imr_ifindex = ifaceInexe;

    int ret;
    ret = setsockopt (getSocketFD(),
                IPPROTO_IP,
                IP_ADD_MEMBERSHIP,
                (char*)&mreqn,    
                sizeof(struct ip_mreqn));
//     cerr << "setsockopt ret = " << ret << endl;
//     cerr << "setsockopt errno = " << errno << endl;
#else
    struct ip_mreq mreq;
    mreq.imr_multiaddr.s_addr=(group.getIp4Address());

    mreq.imr_interface.s_addr=(iface->getIp4Address());
//    mreq.imr_ifindex = ifaceInexe;

    int ret;
    ret = setsockopt (getSocketFD(),
                IPPROTO_IP,
                IP_ADD_MEMBERSHIP,
                (char*)&mreq,    
                sizeof(struct ip_mreq));
#endif
}
    
///
void 
UdpStack::leaveMulticastGroup( NetworkAddress group,
                               NetworkAddress* iface,
                               int ifaceInexe )
{
#if defined(__linux__)
    struct ip_mreqn mreqn;
    mreqn.imr_multiaddr.s_addr=(group.getIp4Address());
    mreqn.imr_address.s_addr=(iface->getIp4Address());
    mreqn.imr_ifindex = ifaceInexe;

    setsockopt (getSocketFD(),
                IPPROTO_IP,
                IP_DROP_MEMBERSHIP,
                (char*)&mreqn,    
                sizeof(struct ip_mreqn));
#else
    struct ip_mreq mreq;
    mreq.imr_multiaddr.s_addr=(group.getIp4Address());
    mreq.imr_interface.s_addr=(iface->getIp4Address());
//    mreq.imr_ifindex = ifaceInexe;

    setsockopt (getSocketFD(),
                IPPROTO_IP,
                IP_DROP_MEMBERSHIP,
                (char*)&mreq,    
                sizeof(struct ip_mreq));
#endif
}

UdpStack::~UdpStack()
{
    assert(data);
    if (logFlag)
    {
        in_log->close();
        out_log->close();

        delete in_log;
        delete out_log;
    }
    close (data->socketFd);
    delete data; data=NULL;
}


int  
UdpStack::getBytesReceived ()
{
    return numBytesReceived;
}

int  
UdpStack::getPacketsReceived ()
{
    return numPacketsReceived;
}

int    
UdpStack::getBytesTransmitted ()
{
    return numBytesTransmitted;
}

int  
UdpStack::getPacketsTransmitted ()
{
    return numPacketsTransmitted;
}


