/*********************************************************************

 $Id: VConditionException.hxx,v 1.2 2000/01/11 00:56:00 bogawa Exp $

 *********************************************************************

  This library is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.  In addition to the
  terms and conditions set forth in the GNU Lesser General Public
  License, as a condition of using this library you are required to
  grant to all users of this library or any implementation utilizing
  or derived from this library a reciprocal, no cost, worldwide,
  perpetual, non-exclusive, non-transferable, unrestricted license to
  your claims of all patents and patent applications throughout the
  world that are infringed by the library or any implementation
  utilizing or derived from this library.  In the event you
  redistribute this library or any implementation utilizing or derived
  from this library, you must prominently display the foregoing terms
  and conditions with the library or the implementation utilizing or
  derived from this library.

  In the event of a conflict of terms between the foregoing license
  grant and the terms set forth in the GNU Lesser General Public
  License, the foregoing terms and conditions shall be deemed to
  govern.

  This library is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not; write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA.

  Copyright 1999-2000 Vovida Networks, Inc.  All Rights Reserved.

 *********************************************************************

 $Log: VConditionException.hxx,v $
 Revision 1.2  2000/01/11 00:56:00  bogawa
 copyright notice fixes for year 2000

 Revision 1.1  1999/12/23 21:02:37  eckelcu
 	Makefile VException.cxx VException.hxx VThread.h
 	VThreadException.cxx vthread-linux.cxx vthread-vxworks.cxx
 	test/VThreadTest.cxx
 Added Files:
 	VConditionException.cxx VConditionException.hxx
 Additional error and exception handling in VThread class


 ********************************************************************/

#ifndef VCONDITION_EXCEPTION_HXX
#define VCONDITION_EXCEPTION_HXX

#include "VException.hxx"

/// VCondition base exception class
class VConditionException: protected VException
{
protected:
    
    VConditionException( const string& msg,
			 const string& file,
			 const int line,
			 const int error = 0 );
    
    ///
    virtual string getName( void ) const = 0;
};

    
/// VCondition exception classes

class VConditionExceptionThreadWaiting: protected VConditionException
{
public:
    VConditionExceptionThreadWaiting( const string& msg,
				      const string& file,
				      const int line,
				      const int error = 0 );

    string getName( void ) const;
};

#endif // VCONDITION_EXCEPTION_HXX
