/*********************************************************************

 $Id: debug.h,v 1.8 2000/01/11 00:56:00 bogawa Exp $

 *********************************************************************

  This library is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.  In addition to the
  terms and conditions set forth in the GNU Lesser General Public
  License, as a condition of using this library you are required to
  grant to all users of this library or any implementation utilizing
  or derived from this library a reciprocal, no cost, worldwide,
  perpetual, non-exclusive, non-transferable, unrestricted license to
  your claims of all patents and patent applications throughout the
  world that are infringed by the library or any implementation
  utilizing or derived from this library.  In the event you
  redistribute this library or any implementation utilizing or derived
  from this library, you must prominently display the foregoing terms
  and conditions with the library or the implementation utilizing or
  derived from this library.

  In the event of a conflict of terms between the foregoing license
  grant and the terms set forth in the GNU Lesser General Public
  License, the foregoing terms and conditions shall be deemed to
  govern.

  This library is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not; write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA.

  Copyright 1999-2000 Vovida Networks, Inc.  All Rights Reserved.

 *********************************************************************

 $Log: debug.h,v $
 Revision 1.8  2000/01/11 00:56:00  bogawa
 copyright notice fixes for year 2000

 Revision 1.7  1999/12/24 02:10:12  tina
 Added consistent cvs header and LGPL license info. to all the above
 files in /util.

 Revision 1.6  1999/11/18 00:28:49  bogawa
 Add changes to use the util directory as well as try to make it possible to take out the calls to cout.

 Revision 1.5  1999/10/25 22:02:19  bogawa
 merge from irix6-0914 back into the main branch

 Revision 1.2.2.2  1999/09/16 23:26:01  bogawa
 merge back fixes from main

 Revision 1.4  1999/09/16 21:57:24  bogawa
 Stack fixes for the telogy boxes as well as out-of-order, mesage overlap, etc.

 Revision 1.3  1999/09/15 23:55:55  bogawa
 merge in changes from irix6-0914 -- merge-irix6-0914-B01

 Revision 1.2.2.1  1999/09/15 03:12:49  bogawa
 debugging changes in gateway; printouts in stack quelled

 Revision 1.2  1999/09/13 20:40:59  bogawa

 changes for async as well as other useful fixes.

 Revision 1.1  1999/08/19 00:07:52  bogawa

 API change
  Modified Files:
  	Makefile commandCoding.cxx commandCoding.hxx eventCoding.cxx
  	eventCoding.hxx parameterCoding.cxx parameterCoding.hxx
  	sdp.cxx sdp.hxx support.cxx support.hxx udpTransport.cxx
  	udpTransport.hxx
  Added Files:
  	debug.cxx debug.h sptr.hxx

 ********************************************************************/

#ifndef DEBUG_H_
#define DEBUG_H_

extern int MY_DEBUG_LEVEL;

extern bool DEBUG_SDP;
extern bool DEBUG_PARSE;
extern bool DEBUG_NTWK;
extern bool DEBUG_NTWK_TIME;
extern bool DEBUG_LOWLEVEL;

#if defined(NDEBUG) || defined(NO_IOSTREAMS_)
#define DEBUG(x) ;
#define HIGH_DEBUG(x) ;
#define XDEBUG(y, x) ;
#define ODEBUG(z, y, x) ;
#define CERR(x) ;
#else
#define DEBUG(x) if(MY_DEBUG_LEVEL > 0) { x; }
#define HIGH_DEBUG(x) if(MY_DEBUG_LEVEL > 2) { x; }
#define XDEBUG(y, x) if(MY_DEBUG_LEVEL > y) { x; }
#define ODEBUG(z, y, x) if(z && (MY_DEBUG_LEVEL > y)) { x; }
#define CERR(x) { x; }
void breakpoint();
#endif


#endif
