/*********************************************************************

 $Id: parse3tuple.h,v 1.6 2000/05/28 21:26:23 chok Exp $

 *********************************************************************

  This library is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.  In addition to the
  terms and conditions set forth in the GNU Lesser General Public
  License, as a condition of using this library you are required to
  grant to all users of this library or any implementation utilizing
  or derived from this library a reciprocal, no cost, worldwide,
  perpetual, non-exclusive, non-transferable, unrestricted license to
  your claims of all patents and patent applications throughout the
  world that are infringed by the library or any implementation
  utilizing or derived from this library.  In the event you
  redistribute this library or any implementation utilizing or derived
  from this library, you must prominently display the foregoing terms
  and conditions with the library or the implementation utilizing or
  derived from this library.

  In the event of a conflict of terms between the foregoing license
  grant and the terms set forth in the GNU Lesser General Public
  License, the foregoing terms and conditions shall be deemed to
  govern.

  This library is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not; write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA.

  Copyright 1999-2000 Vovida Networks, Inc.  All Rights Reserved.

 *********************************************************************

 $Log: parse3tuple.h,v $
 Revision 1.6  2000/05/28 21:26:23  chok
 Base code changes for new user agent

 Revision 1.5  2000/03/03 20:48:07  chok
 add strConst2i function

 Revision 1.4  2000/01/11 00:56:01  bogawa
 copyright notice fixes for year 2000

 Revision 1.3  1999/12/24 02:10:12  tina
 Added consistent cvs header and LGPL license info. to all the above
 files in /util.

    
 ********************************************************************/

#ifndef PARSE3TUPLE_H
#define PARSE3TUPLE_H       

#define TUPLE3_MAX_LENGTH 1024
#define TAG_MAX_LENGTH 96
#define TYPE_MAX_LENGTH 32
#define VALUE_MAX_LENGTH TUPLE3_MAX_LENGTH - TAG_MAX_LENGTH - TYPE_MAX_LENGTH

/*
 * parse3tuple() parses file fname line by line. Each line is expected
 * to have 3 fields, <tag>-<type>-<value>, separated by blanks or tabs.
 * Lines starting with '#' are comments. Empty lines are ignored.
 * The value field contains a number of characters, even field separators
 * like blanks and tabs, up to the end of the line.
 * User of this utility provides a call back function with 3 arguments
 * (pointers to the tag, type and value strings) to validate and use the
 * data.
 * usage example: if (!parse3tuple ("cs.cfg", processCsConfigData))
 *                    exit (0);
 */
extern bool parse3tuple (const char*, void (*f) (char*, char*, char*));

extern int strConst2i (const char*str, const char* strTable[], const int tableSize);

/* PARSE3TUPLE_H  */
#endif
