/*********************************************************************

 $Id: support.cxx,v 1.27 2000/05/01 19:06:14 bogawa Exp $

 *********************************************************************

  This library is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.  In addition to the
  terms and conditions set forth in the GNU Lesser General Public
  License, as a condition of using this library you are required to
  grant to all users of this library or any implementation utilizing
  or derived from this library a reciprocal, no cost, worldwide,
  perpetual, non-exclusive, non-transferable, unrestricted license to
  your claims of all patents and patent applications throughout the
  world that are infringed by the library or any implementation
  utilizing or derived from this library.  In the event you
  redistribute this library or any implementation utilizing or derived
  from this library, you must prominently display the foregoing terms
  and conditions with the library or the implementation utilizing or
  derived from this library.

  In the event of a conflict of terms between the foregoing license
  grant and the terms set forth in the GNU Lesser General Public
  License, the foregoing terms and conditions shall be deemed to
  govern.

  This library is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not; write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA.

  Copyright 1999-2000 Vovida Networks, Inc.  All Rights Reserved.

 *********************************************************************

 $Log: support.cxx,v $
 Revision 1.27  2000/05/01 19:06:14  bogawa
 fixes for FreeBSD compiling in util directory

 Revision 1.26  2000/02/24 02:19:42  hong
 Implemented at-most-once functionality/re-send on timeout in MGCP

 Revision 1.25  2000/01/11 00:56:01  bogawa
 copyright notice fixes for year 2000

 Revision 1.24  2000/01/05 00:27:57  bogawa
 warning fixes

 Revision 1.23  1999/12/10 09:19:43  bogawa
 low level support for embedded requests

 Revision 1.22  1999/11/30 02:09:31  eckelcu
 Modified Files:
 	Data.cxx Data.hxx DataBuff.cxx DataBuff.hxx cpLog.cxx
 	debug.cxx fifo.cxx parse3tuple.cxx parse3tupleTest.cxx
 	sptr.hxx support.cxx support.hxx timer.cxx udp.cxx udp.hxx
 	udpTransport.cxx udpTransport.hxx vcondition-linux.cxx
 	vcondition-vxworks.cxx vmutex-linux.cxx vmutex-vxworks.cxx
 	vthread-linux.cxx vthread-vxworks.cxx vtime-vxworks.cxx
 Added consistent cvs header and LGPL license info to all files in /util

 Revision 1.21  1999/11/19 01:39:56  bogawa
 fixes and changes for building the SH targets successfully

 Revision 1.20  1999/11/18 00:28:49  bogawa
 Add changes to use the util directory as well as try to make it
 possible to take out the calls to cout.

 Revision 1.20  1999/11/05 01:21:41  bogawa
 fixes for the stack to make it work again (hopefully).

 Revision 1.19  1999/11/03 06:25:01  bogawa
 fixed testcase compiling.  began adding support for embedded requests

 Revision 1.18  1999/10/25 22:02:20  bogawa
 merge from irix6-0914 back into the main branch

 Revision 1.15.2.9  1999/10/12 01:00:57  bogawa
 miscellaneous fixes including SDP fixes. Adds SDP test case, as well
 as other test cases

 Revision 1.15.2.8  1999/10/01 03:46:56  bogawa
 more performance stuff

 Revision 1.15.2.7  1999/09/30 23:48:47  bogawa
 updated for the new sub_split as well as the substring stuff to
 correct and support it.

 Revision 1.15.2.6  1999/09/30 20:45:01  bogawa
 performance fixes.

 Revision 1.15.2.5  1999/09/30 05:00:19  bogawa
 improve performance by replacing vector with deque

 Revision 1.15.2.4  1999/09/30 03:39:35  devel
 good fixes for callAgent and gateway

 Revision 1.15.2.3  1999/09/30 00:51:05  bogawa
 fixes for new code

 Revision 1.15.2.2  1999/09/16 23:26:01  bogawa
 merge back fixes from main

 Revision 1.17  1999/09/16 21:57:24  bogawa
 Stack fixes for the telogy boxes as well as out-of-order, mesage overlap, etc.

 Revision 1.16  1999/09/15 23:55:55  bogawa
 merge in changes from irix6-0914 -- merge-irix6-0914-B01

 Revision 1.15.2.1  1999/09/15 00:24:20  bogawa
 merge in cheung's changes and changes to compile under sgi

 Revision 1.15  1999/09/13 20:40:59  bogawa

 changes for async as well as other useful fixes.

 Revision 1.14  1999/08/24 00:29:16  bogawa

 merge in preliminary case-insensitivity as well as comma separator
 support.

  Modified Files:
  	commandCoding.cxx commandCoding.hxx eventCoding.cxx
 	eventCoding.hxx parameterCoding.cxx parameterCoding.hxx
 	sdp.cxx support.cxx support.hxx

 Revision 1.13  1999/08/19 00:07:52  bogawa

 API change
  Modified Files:
  	Makefile commandCoding.cxx commandCoding.hxx eventCoding.cxx
  	eventCoding.hxx parameterCoding.cxx parameterCoding.hxx
  	sdp.cxx sdp.hxx support.cxx support.hxx udpTransport.cxx
  	udpTransport.hxx
  Added Files:
  	debug.cxx debug.h sptr.hxx

 Revision 1.12.2.2  1999/08/13 19:32:52  bogawa
 update the mgcp code to add some more stuff.

 Revision 1.12.2.1  1999/08/06 00:13:03  bogawa
 lowercase and case insensitivity stuff.

 Revision 1.12  1999/08/05 00:50:35  bogawa
 fix for itos.

 Revision 1.11  1999/08/05 00:35:39  bogawa
 fix itos function.

 Revision 1.10  1999/08/04 02:21:54  bogawa
 fix the local connection options code (trivial support only)

 Revision 1.9  1999/08/04 00:57:33  bogawa
 fixes...

 Revision 1.8  1999/07/27 00:23:01  bogawa
 Add Win32 (Visual c++ 6) compilation support

 Revision 1.7  1999/06/30 06:09:08  bogawa
 update copyright and license

 Revision 1.6  1999/06/29 23:42:03  bogawa
 Updated copyright notice.

 Revision 1.5  1999/06/28 21:30:37  bogawa
 Update to the latest version of the MGCP stack.

 Revision 1.4  1999/06/09 08:16:44  bogawa
 Add copyright notices.

 Revision 1.3  1999/06/09 01:04:59  bogawa
 Changes to make the new structure compile correctly, and to allow the
 code to use the new hardware structure.  gateway1 is now using the
 new structure fully, while gateway2 is using it partially (actually
 not very much).
 A future version should be much cleaner.

    
 ********************************************************************/

#include "StdAfx.h"
#include "support.hxx"
#ifdef __FreeBSD__
#include <sys/types.h>
#endif
#include <regex.h>
#include "debug.h"
#include <set>


/**********************************************************************

Support functions for the MGCP library.

**********************************************************************/


bool isIn(char ch, const string& charlist)
{
    string::size_type pos = charlist.find_first_of(ch);
    if(pos != string::npos)
    {
	return true;
    }
    else
    {
	return false;
    }
}


substring
paren_match(const string& inputText)
{
    // create a substring from inputText and call it
    substring subInputText(&inputText, 0, inputText.length());
    return paren_match(subInputText);
}


substring
paren_match(const substring& inputText)
{
    string::size_type position = 0, firstParenLocation = string::npos;
    bool foundFirstParen = false;
    int parenCount = 0;

    while(
	position < inputText.length()
	&& !(foundFirstParen && (parenCount == 0))
	)
    {
	// scan for the first paren
	char currentChar = const_cast<substring&>(inputText)[position];
	if(currentChar == '(')
	{
	    if(!foundFirstParen)
	    {
		foundFirstParen = true;
		firstParenLocation = position;
	    }
	    parenCount++;
	}

	else if(currentChar == ')')
	{
	    if(foundFirstParen)
	    {
		parenCount--;
	    }
	}
	position++;
    }

    if(foundFirstParen && (parenCount == 0))
    {
	// in this case, create a substring based on this one
	ODEBUG(DEBUG_LOWLEVEL, 2, cout << ":" << inputText.str().substr(firstParenLocation + 1, (position - firstParenLocation - 2)) << ":\n";);
	substring retVal(inputText, firstParenLocation + 1, position - firstParenLocation - 2);
	return retVal;
    }
    else
    {
	// in this case, it is an error
	cerr << "could not match the string" << endl;
	if(firstParenLocation != string::npos)
	{
	    substring errVal(inputText, firstParenLocation, inputText.length() - firstParenLocation);
	    cerr << "string: " << errVal << endl;
	}
	return substring();
    }
    return substring();
}


sub_split_t 
sub_split_paren_match(const string& inputText, const string& characters)
{
    string::size_type position = 0, oldPosition = 0;

    sub_split_t splitted;

    unsigned int length = inputText.length();

    while(position < length)
    {
	// the code must loop through the entire text to make sure it
	// matches parentheses

	int parenCount = 0;

	while((position < length)
	      && !(isIn(inputText[position], characters) && (parenCount == 0))
	    )
	{
	    char currentChar = inputText[position];

	    if(currentChar == '(')
	    {
		parenCount++;
	    }

	    if(currentChar == ')')
	    {
		parenCount--;
	    }
	    position++;
	}

	if(position == string::npos)
	    position = inputText.length();

	if(parenCount != 0)
	{
	    // we reached the end without balanced parentheses -- mark as an
	    // error and continue
	    cerr << "this is an error" << endl;

	}

	ODEBUG(DEBUG_LOWLEVEL, 2, cout << inputText.substr(oldPosition, (position - oldPosition)););
	ODEBUG(DEBUG_LOWLEVEL, 2, cout << ":\n";);
	(splitted).push_back(
	    substring(
		&inputText, oldPosition, (position - oldPosition))
	    );
	oldPosition = inputText.find_first_not_of(characters, position);
	if(oldPosition == string::npos)
	    oldPosition = inputText.length();

	position = oldPosition;
    }

    ODEBUG(DEBUG_LOWLEVEL, 2, cout << "number of lines: " << splitted.size() << endl;);

    return splitted;
}


sub_split_t sub_split(const string& inputText, const string& characters)
{
    string::size_type position = 0, oldPosition = 0;

    sub_split_t splitted;

    unsigned int length = inputText.length();

    while(position < length)
    {
	position = inputText.find_first_of(characters, oldPosition);
	// advance forward and eat all characters of type characters

	if(position == string::npos)
	    position = inputText.length();

	ODEBUG(DEBUG_LOWLEVEL, 2, cout << inputText.substr(oldPosition, (position - oldPosition)););
	ODEBUG(DEBUG_LOWLEVEL, 2, cout << ":\n";);
	(splitted).push_back(
	    substring(
		&inputText, oldPosition, (position - oldPosition))
	    );
	oldPosition = inputText.find_first_not_of(characters, position);
	if(oldPosition == string::npos)
	    oldPosition = inputText.length();
	position = oldPosition;

    }
    ODEBUG(DEBUG_LOWLEVEL, 2, cout << "number of lines: " << splitted.size() << endl;);

    return splitted;
}


split_t split(const string& inputText, const string& characters)
{
    // this is the original split definition, which I think may be inefficient
    // I will instead try a more efficient way of doing things.

    string::size_type position = 0, oldPosition = 0;

    split_t splitted;

    unsigned int length = inputText.length();

    while(position < length)
    {
	position = inputText.find_first_of(characters, oldPosition);
	if(position == string::npos)
	    position = inputText.length();
	ODEBUG(DEBUG_LOWLEVEL, 2, cout << inputText.substr(oldPosition, (position - oldPosition)););
	ODEBUG(DEBUG_LOWLEVEL, 2, cout << ":\n";);
	(splitted).push_back(
	    inputText.substr(oldPosition, (position - oldPosition)));
	oldPosition = position + 1;
    }
    return splitted;
}

vector<string> new_split(const string& inputText, const string& characters)
{
    vector<string> splitted;
#if 0
    // this is the original split definition, which I think may be inefficient
    // I will instead try a more efficient way of doing things.

    string::size_type position = 0, oldPosition = 0;

    vector<string> splitted;

    unsigned int length = inputText.length();

    while(position < length)
    {
	position = inputText.find_first_of(characters, oldPosition);
	if(position == string::npos)
	    position = inputText.length();
	ODEBUG(DEBUG_LOWLEVEL, 2, cout << inputText.substr(oldPosition, (position - oldPosition)););
	ODEBUG(DEBUG_LOWLEVEL, 2, cout << ":\n";);
	(splitted).push_back(
	    inputText.substr(oldPosition, (position - oldPosition)));
	oldPosition = position + 1;
    }
    return splitted;

    // this is the new way

    // build a set

    set<char> charSet;

    string::size_type charPos = 0;
    string::size_type charLen = characters.length();
    while(charPos < charLen)
    {
	charSet.insert(characters[charPos]);
	charPos++;
    }
    

    string::size_type position = 0;
    string::size_type length = inputText.length();

    vector<string> splitted;

    bool inDividingChar = true;

    while(position < length)
    {
	if(!inDividingChar)
	{
	    if(charSet.find(inputText[position]) != charSet.end())
	    {
		inDividingChar = true;
	    }
	}
	if(charSet.find(inputText[position]) == charSet.end())
	{
	    if(inDividingChar)
	    {
		splitted.push_back(string("", 20));
	    }
	    inDividingChar = false;
	    splitted.back() += inputText[position];
	}
	position++;
    }
    return splitted;
#endif
    return splitted;
}


void chop(string* input)
{
    string::iterator p = input->end();

    if(p != input->begin())
	--p;
    input->erase(p);
}

void chomp(string* input)
{
    size_t i;

    i = input->length() - 1;

    if(i >=0)
    {
	if( ((*input)[i] == '\n' ) ||
	    ((*input)[i] == '\r'))
	{
	    input->erase(i, 1);
	}
    }
}



string str2lower(string str)
{
    unsigned int i = 0;
    unsigned int size = str.size();

    while(i < size)
    {
	str[i] = tolower(str[i]);
	i++;
    }
    return str;
}

string c2lower_s(const char* cstr)
{
    string str;
//    unsigned int i = 0;

    while(cstr && *cstr)
    {
	str += tolower(*cstr);
	cstr++;
    }
    return str;
}


int matchString(string a, string regex)
{
    regex_t re;
    int     status;


    if((status=regcomp( &re, regex.c_str(), REG_EXTENDED))!= 0)
	return(status);
    status = regexec( &re, a.c_str(), 0, NULL, 0);
    return(status);
}


bool stringToInt ( const string& s, int *num)
{
    /// skipping spaces in the front
  //   string::size_type position = 0;
  //  position = s.find_first_not_of(string(" "), 0);
 
  int position = 0;

  for (int i=0, j=s.length(); i<j; i++)
  {
    if (s[i] != ' ')
      {
	position = i;
        break;
      }
  }


    /// convert the string to integer
    char ch;
    int value=0;
    for (int i=position, j=s.length(); i<j; i++)
    {
      ch = s[i];
      if ( (ch>='0')&&(ch<='9') )
        value = atoi(&ch)+ value*10;
      else if ( ch == ' ' )
	break;  /// a whole number is read
      else
	return (false);  /// illegal char, not a digit or space
    }

    *num = value;
    return (true);
}



bool getRange( const string& s, int* start, int* end, bool* isRange)
{
  /// initialize all possible returns
  *start = 0;
  *end = 0;
  *isRange = false;

  /// split the range into two integers, assuming the numbers
  /// are separeted by '-'.
  // deque<string> test_1_vector;
  //sub_split_t test_1_vector;
  split_t test_1_vector;

  // string myStr(s.str());

  //test_1_vector = sub_split(myStr, "-");
  test_1_vector = split( s, "-");

  /// read in the first integer if any
  if (test_1_vector.size() >=1 )
  {
    if (!stringToInt( test_1_vector[0], start))  // if (true), a valid integer is read into start variable
      return (false); // first number is not a valid integer
  }
  else
    return (false);  // no data in the input string at all

  /// read in the second integer if any
  if (test_1_vector.size() >=2 )
  {
    if (stringToInt( test_1_vector[1], end))  // if (true), a valid second integer is read into end variable
    {
      if (*start <= *end )
	*isRange = true;  // got a valid range
      else
	return (false);  // range is not valid, larger number went first
    }
    else
      return (false);  // second number after '-' is not valid, ignore the range
  }

  return (true); // success in getting one or two valid integers from string
}



