/*********************************************************************

 $Id: support.hxx,v 1.23 2000/05/01 19:06:14 bogawa Exp $

 *********************************************************************

  This library is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.  In addition to the
  terms and conditions set forth in the GNU Lesser General Public
  License, as a condition of using this library you are required to
  grant to all users of this library or any implementation utilizing
  or derived from this library a reciprocal, no cost, worldwide,
  perpetual, non-exclusive, non-transferable, unrestricted license to
  your claims of all patents and patent applications throughout the
  world that are infringed by the library or any implementation
  utilizing or derived from this library.  In the event you
  redistribute this library or any implementation utilizing or derived
  from this library, you must prominently display the foregoing terms
  and conditions with the library or the implementation utilizing or
  derived from this library.

  In the event of a conflict of terms between the foregoing license
  grant and the terms set forth in the GNU Lesser General Public
  License, the foregoing terms and conditions shall be deemed to
  govern.

  This library is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not; write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA.

  Copyright 1999-2000 Vovida Networks, Inc.  All Rights Reserved.

 *********************************************************************

 $Log: support.hxx,v $
 Revision 1.23  2000/05/01 19:06:14  bogawa
 fixes for FreeBSD compiling in util directory

 Revision 1.22  2000/03/23 07:20:23  bogawa
 fix for support not compiling

 Revision 1.21  2000/02/24 02:19:31  hong
 Implemented at-most-once functionality/re-send on timeout in MGCP

 Revision 1.20  2000/01/11 00:56:01  bogawa
 copyright notice fixes for year 2000

 Revision 1.19  2000/01/05 00:27:57  bogawa
 warning fixes

 Revision 1.18  1999/11/30 02:09:31  eckelcu
 Modified Files:
 	Data.cxx Data.hxx DataBuff.cxx DataBuff.hxx cpLog.cxx
 	debug.cxx fifo.cxx parse3tuple.cxx parse3tupleTest.cxx
 	sptr.hxx support.cxx support.hxx timer.cxx udp.cxx udp.hxx
 	udpTransport.cxx udpTransport.hxx vcondition-linux.cxx
 	vcondition-vxworks.cxx vmutex-linux.cxx vmutex-vxworks.cxx
 	vthread-linux.cxx vthread-vxworks.cxx vtime-vxworks.cxx
 Added consistent cvs header and LGPL license info to all files in /util

 Revision 1.17  1999/11/18 00:28:49  bogawa
 Add changes to use the util directory as well as try to make it
 possible to take out the calls to cout.

 Revision 1.17  1999/11/05 01:21:41  bogawa
 fixes for the stack to make it work again (hopefully).

 Revision 1.16  1999/11/03 06:25:01  bogawa
 fixed testcase compiling.  began adding support for embedded requests

 Revision 1.15  1999/10/25 22:02:20  bogawa
 merge from irix6-0914 back into the main branch

 Revision 1.13.4.8  1999/10/01 03:46:56  bogawa
 more performance stuff

 Revision 1.13.4.7  1999/09/30 23:48:48  bogawa
 updated for the new sub_split as well as the substring stuff to correct
 and support it.

 Revision 1.13.4.6  1999/09/30 21:10:18  bogawa
 performance and timing fixes

 Revision 1.13.4.5  1999/09/30 20:45:01  bogawa
 performance fixes.

 Revision 1.13.4.4  1999/09/30 05:00:19  bogawa
 improve performance by replacing vector with deque

 Revision 1.13.4.3  1999/09/30 00:51:05  bogawa
 fixes for new code

 Revision 1.13.4.2  1999/09/16 23:26:01  bogawa
 merge back fixes from main

 Revision 1.14  1999/09/15 23:55:55  bogawa
 merge in changes from irix6-0914 -- merge-irix6-0914-B01

 Revision 1.13.4.1  1999/09/15 00:24:20  bogawa
 merge in cheung's changes and changes to compile under sgi

 Revision 1.13  1999/08/24 00:29:16  bogawa
 merge in preliminary case-insensitivity as well as comma separator
 support.
  Modified Files:
  	commandCoding.cxx commandCoding.hxx eventCoding.cxx
 	eventCoding.hxx parameterCoding.cxx parameterCoding.hxx
 	sdp.cxx support.cxx support.hxx

 Revision 1.12  1999/08/19 00:07:52  bogawa
 API change
  Modified Files:
  	Makefile commandCoding.cxx commandCoding.hxx eventCoding.cxx
  	eventCoding.hxx parameterCoding.cxx parameterCoding.hxx
  	sdp.cxx sdp.hxx support.cxx support.hxx udpTransport.cxx
  	udpTransport.hxx
  Added Files:
  	debug.cxx debug.h sptr.hxx

 Revision 1.11.2.2  1999/08/13 19:32:52  bogawa
 update the mgcp code to add some more stuff.

 Revision 1.11.2.1  1999/08/06 00:13:03  bogawa
 lowercase and case insensitivity stuff.

 Revision 1.11  1999/08/05 00:35:39  bogawa
 fix itos function.

 Revision 1.10  1999/08/04 00:57:33  bogawa
 fixes...

 Revision 1.9  1999/07/27 00:23:01  bogawa
 Add Win32 (Visual c++ 6) compilation support

 Revision 1.8  1999/07/23 23:57:25  bogawa
 the mgcp/examples/gateway Makefile was changed to use the new 
 make file system.

 improve the global makefiles.  Now, most targets use these makefiles
 which should simplify the lives of the users, we hope.
 Key features include support for nested object directories as well as
 a more coherent install strategy (so that installs are less likely to
 produce error messages)
 in addition, the code was cleaned up to add a few new features and to
 remove some warnings.

 Revision 1.7  1999/06/30 06:09:08  bogawa
 update copyright and license

 Revision 1.6  1999/06/29 23:42:03  bogawa
 Updated copyright notice.

 Revision 1.5  1999/06/28 21:30:37  bogawa
 Update to the latest version of the MGCP stack.

 Revision 1.4  1999/06/09 08:16:44  bogawa
 Add copyright notices.

 Revision 1.3  1999/06/09 04:09:46  bogawa
 This makefile now correctly does diving makes.
 In addition, the code has been cleaned up and adds some comments for doc++.
 doc++ can be invoked by using make doc -- the current version will be shipped
 with  appropriate html documentation.

 Revision 1.2  1999/06/09 01:04:59  bogawa
 Changes to make the new structure compile correctly, and to allow the
 code to use the new hardware structure.  gateway1 is now using the
 new structure fully, while gateway2 is using it partially (actually
 not very much).
 A future version should be much cleaner.
    
 ********************************************************************/

#ifndef SUPPORT_HXX_
#define SUPPORT_HXX_

#include "global.h"
#include <stdio.h>
#include <vector>
#include <deque>
#include <string>
#include "substring.h"

/***********************************************************************

  Utility and support functions for the stack.

 **********************************************************************/

#ifndef __sparc

#ifndef __FreeBSD__
typedef deque<substring> sub_split_t;
typedef deque<string> split_t;
#else
typedef vector<substring> sub_split_t;
typedef vector<string> split_t;
#endif

#else
typedef vector<substring> sub_split_t;
typedef vector<string> split_t;
#endif


/** paren_match will return the data that is in the first matched
    set of parentheses.

    e.g. if the text is like this:

    foo(la, la, la)

    it will return a substring pointing to "la, la, la" (no quotes,
    obviously)

    or, if it is

    (a, b(d, e(g, h), f), c)

    it will return "a, b(d, e(g, h), f), c" .

    paren_match will work both on strings and substrings.

*/
substring 
paren_match(const string& inputText);


/// same as the one for strings, but for substrings
substring 
paren_match(const substring& inputText);



/** splits a string into a vector of substrings while first matching
   parentheses.

   This function will NOT match the characters when they are inside
   brackets.  At the moment, this is specialized to only match "()" as
   brackets, although this may change in the future.

   sub_split_paren_patch does not copy the strings itself.  Instead,
   it substrings, which are pointers into the original string and
   length counts.

   The substring.h file contains the useful information about what a
   substring is, and what you can do with one.

   Clearly, this was influenced by perl.  */
sub_split_t 
sub_split_paren_match(const string& inputText, const string& characters);


/**
   splits a string into a vector of substrings. 

   This version is more efficient than split() because it does not
   copy the strings itself.  Instead, it uses substrings, which are
   pointers into the original string and length counts.

   The substring.h file contains the useful information about what a
   substring is, and what you can do with one.

   Clearly, this was influenced by perl.  */
sub_split_t 
sub_split(const string& inputText, const string& characters);


/**
   splits a string into a vector of substrings. 

   This is inefficient because copying is generally involved here.  A
   more efficient implementation which uses pointers into the original
   string (and length counts) may replace this in a future version.

   Clearly, this was influenced by perl.
*/
split_t 
split(const string& inputText, const string& characters);


/// slower, new split code
vector<string> 
new_split(const string& inputText, const string& characters);


/**
   removes the trailing character from a string.

   Clearly, this was influenced by perl.
*/
void 
chop(string* input);


/** 
    removes the trailing character from a string if it is \r or \n.

    Clearly, this was influenced by perl.
*/
void 
chomp(string* input);


/**
   convert an int to a string
*/
inline string itos(unsigned int i)
{
#if 0
    char buf[32];
    int index = 0;
    string s;

    s.reserve(32);

    if(i == 0)
    {
	index = 1;
	buf[0] = '0';
    }

    while(i)
    {
	buf[index] = i % 10 + '0';
        i = i / 10;
	index++;
    }

    for(int j = 1; j <= index; j++)
    {
	s += buf[index-j];
    }

    return s;
#endif
    char buf[32];
    sprintf(buf, "%d", i);
    return buf;
}


///
inline string itohexs(unsigned int i)
{
#if 0
    char buf[32];
    int index = 0;
    string s;

    s.reserve(32);

    if(i == 0)
    {
	index = 1;
	buf[0] = '0';
    }

    while(i)
    {
	int r = i % 16;
	if ( r < 10)
	{
	    buf[index] = r + '0';
	}
	else
	{
	    buf[index] = (r - 10) + 'a';
	}
        i = i / 16;
	index++;
    }

    for(int j = 1; j <= index; j++)
    {
	s += buf[index-j];
    }

    return s;
#endif
    char buf[32];
    sprintf(buf, "%x", i);
    return buf;
}


/**
   returns a string converted to lowercase.
*/
string 
str2lower(string str);


/**
   returns a string converted to lowercase.
*/
string 
c2lower_s(const char* cstr);


/**
   check to see if a string is all legal digit characters
*/

int 
matchString(string a, string regex);

/**
    Template simulates a pointer with a "smart" reference that deletes
    the item when no more references exist
*/


/**
    get the integer from the string s, e.g. "   2598   ", it may contain
    arbituary spaces in the front or end, but not in between digits
    otherwise, the first whole integer is read and returned,
    e.g. "  235   67" is returned as 235.
    if true is returned, the num variable contains a valid integer for use
*/
bool stringToInt ( const string& s, int *num);


/**
    Assume the string s contains an integer or a number
    range between two integers, e.g. 20 or 23-45.
    Returns: If string s contains only a single integer, it is
    returned in start variable and isRange is set to false, and the function
    in whole returns true.
    If string s contains a range, start variable will contain
    the starting number, and end variable will contain the ending
    number, and isRange is set to true if the range is valid, i.e. start < end.
    the function in whole returns true.
    Any other case, the function returns false.
*/
bool getRange( const string& s, int* start, int* end, bool* isRange);


#endif
