/*********************************************************************

 $Id: udpInjectSnd.cxx,v 1.3 2000/02/24 00:38:52 wenqing Exp $

 *********************************************************************

  This library is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.  In addition to the
  terms and conditions set forth in the GNU Lesser General Public
  License, as a condition of using this library you are required to
  grant to all users of this library or any implementation utilizing
  or derived from this library a reciprocal, no cost, worldwide,
  perpetual, non-exclusive, non-transferable, unrestricted license to
  your claims of all patents and patent applications throughout the
  world that are infringed by the library or any implementation
  utilizing or derived from this library.  In the event you
  redistribute this library or any implementation utilizing or derived
  from this library, you must prominently display the foregoing terms
  and conditions with the library or the implementation utilizing or
  derived from this library.

  In the event of a conflict of terms between the foregoing license
  grant and the terms set forth in the GNU Lesser General Public
  License, the foregoing terms and conditions shall be deemed to
  govern.

  This library is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not; write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA.

  Copyright 1999-2000 Vovida Networks, Inc.  All Rights Reserved.

 *********************************************************************

 $Log: udpInjectSnd.cxx,v $
 Revision 1.3  2000/02/24 00:38:52  wenqing
 fix for compiling problem for sh_vxwork

 Revision 1.2  2000/02/15 03:56:21  wenqing
 update print out

 Revision 1.1  2000/02/15 03:43:10  wenqing
 adding files of inject udp pkts from log files.
 update for creating the log files.


 ********************************************************************/

#include <unistd.h>
#include <stdio.h>
#include <iostream.h>
#include <fstream>
#include <string.h>
#include <string>
#include <netinet/in.h>
//#include <sys/socket.h>
#include "vsock.hxx"
#include "NetworkAddress.h"
#ifdef __vxworks
#include "VThread.h"
#endif

int main (int argc, char* argv[])
{
    if (argc < 2)
    {
       cerr <<"Usage: udpInjectSnd file \n";
       exit (1);
    }

    ifstream file(argv[1]);
    if (!file)
    {
        cerr << "Could not open file\n";
        return -1;
    }

    struct sockaddr_in xDest;


    char line[256];
    char pkt[4096];


    if (!file.eof())
    {
        memset (line, 0, 256);
        file.getline(line, 256); 
        cout << line << endl; 
    }
    while (!file.eof())
    {

        int ret;

        ret = strcmp(line, "UdpSnd");
        if (ret != 0)
        {
            cout << "Input file is wrong." << endl;
            return -1;
        }


        int socketFd = socket(PF_INET, SOCK_DGRAM, IPPROTO_UDP);
        if (socketFd < 0)
        {
            cout << "Error create socket." << endl;
            return -1;
        }

        if (!file.eof())
        {
            memset (line, 0, 256);
            file.getline(line, 256); 
            cout << line << endl; 
        }
        while (!file.eof())        
        {
            int seqNum=0;
            int len=0;
            char str_seqNum[256];
            char str_len[256];
            char str_host[256];

            ret = sscanf(line, "%s%s%s", str_seqNum, str_len, str_host) ;

            seqNum = atoi(str_seqNum);
            len = atoi(str_len);

            string str_addr(str_host);
            NetworkAddress netAddress(str_addr);

            xDest.sin_family = AF_INET;
            xDest.sin_port = htons(netAddress.getPort());
            xDest.sin_addr.s_addr = netAddress.getIp4Address();

            memset (pkt, 0, 4096);
            file.read(pkt, len);

            int count = sendto( socketFd,
                        (char *) pkt,
                        len,
                        0 /* flags */ ,
                        (struct sockaddr*)&xDest,
                        sizeof(sockaddr_in));
            if (count < 0)
            {
                cout << "error happen when sendto(). "  << seqNum << endl;
                return -1;
            } 
            else
            {
                cout << "send pkt #" << seqNum << endl;
            }
           
            usleep (200); 

            memset (line, 0, 256);
            file.getline(line, 256);
            cout << line << endl;

            memset (line, 0, 256);
            file.getline(line, 256);
            cout << line << endl;

            if (!file.eof())
            {
                memset (line, 0, 256);
                file.getline(line, 256); 
                cout << line << endl; 
            }
        }   
        if (!file.eof())
        {
            memset (line, 0, 256);
            file.getline(line, 256); 
            cout << line << endl; 
        }

    }
    file.close();


}

