/*********************************************************************

 $Id: vmutex-linux.cxx,v 1.4 2000/01/11 00:56:01 bogawa Exp $

 *********************************************************************

  This library is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.  In addition to the
  terms and conditions set forth in the GNU Lesser General Public
  License, as a condition of using this library you are required to
  grant to all users of this library or any implementation utilizing
  or derived from this library a reciprocal, no cost, worldwide,
  perpetual, non-exclusive, non-transferable, unrestricted license to
  your claims of all patents and patent applications throughout the
  world that are infringed by the library or any implementation
  utilizing or derived from this library.  In the event you
  redistribute this library or any implementation utilizing or derived
  from this library, you must prominently display the foregoing terms
  and conditions with the library or the implementation utilizing or
  derived from this library.

  In the event of a conflict of terms between the foregoing license
  grant and the terms set forth in the GNU Lesser General Public
  License, the foregoing terms and conditions shall be deemed to
  govern.

  This library is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not; write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA.

  Copyright 1999-2000 Vovida Networks, Inc.  All Rights Reserved.

 *********************************************************************

 $Log: vmutex-linux.cxx,v $
 Revision 1.4  2000/01/11 00:56:01  bogawa
 copyright notice fixes for year 2000

 Revision 1.3  1999/12/21 21:51:46  bogawa
 fixes for the great renaming

 Revision 1.2  1999/11/30 02:09:31  eckelcu
 Modified Files:
 	Data.cxx Data.hxx DataBuff.cxx DataBuff.hxx cpLog.cxx
 	debug.cxx fifo.cxx parse3tuple.cxx parse3tupleTest.cxx
 	sptr.hxx support.cxx support.hxx timer.cxx udp.cxx udp.hxx
 	udpTransport.cxx udpTransport.hxx vcondition-linux.cxx
 	vcondition-vxworks.cxx vmutex-linux.cxx vmutex-vxworks.cxx
 	vthread-linux.cxx vthread-vxworks.cxx vtime-vxworks.cxx
 Added consistent cvs header and LGPL license info to all files in /util

    
 ********************************************************************/

#ifndef __vxworks
    
#include <cassert>
#include "VMutex.h"

/*********************************************************************

VMutex for Linux

*********************************************************************/
    
VMutex::VMutex (void)
{
    int errorcode = pthread_mutex_init(&myId, NULL);
    assert(!errorcode);
}
    
    
VMutex::~VMutex (void)
{
    int errorcode = pthread_mutex_destroy(&myId);
    assert(!errorcode);
}

    
int
VMutex::lock (void)
{
    return (pthread_mutex_lock(&myId));
}

    
int
VMutex::unlock (void)
{
    return (pthread_mutex_unlock(&myId));
}

    
vmutex_t*
VMutex::getId (void)
{
    return &myId;
}

#endif // not __vxworks
