/*********************************************************************

 $Id: vsock.hxx,v 1.6 2000/01/20 01:07:12 tina Exp $

 *********************************************************************

  This library is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.  In addition to the
  terms and conditions set forth in the GNU Lesser General Public
  License, as a condition of using this library you are required to
  grant to all users of this library or any implementation utilizing
  or derived from this library a reciprocal, no cost, worldwide,
  perpetual, non-exclusive, non-transferable, unrestricted license to
  your claims of all patents and patent applications throughout the
  world that are infringed by the library or any implementation
  utilizing or derived from this library.  In the event you
  redistribute this library or any implementation utilizing or derived
  from this library, you must prominently display the foregoing terms
  and conditions with the library or the implementation utilizing or
  derived from this library.

  In the event of a conflict of terms between the foregoing license
  grant and the terms set forth in the GNU Lesser General Public
  License, the foregoing terms and conditions shall be deemed to
  govern.

  This library is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not; write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA.

  Copyright 1999-2000 Vovida Networks, Inc.  All Rights Reserved.

 *********************************************************************

 $Log: vsock.hxx,v $
 Revision 1.6  2000/01/20 01:07:12  tina
 updated.

 Revision 1.5  2000/01/11 00:56:01  bogawa
 copyright notice fixes for year 2000

 Revision 1.4  2000/01/11 00:54:25  tina
 replace getuid() with getUser().

 Revision 1.3  1999/12/24 01:24:12  tina
 For OS independancy. Added consistent cvs header and LGPL license info.

 Revision 1.2  1999/12/24 00:52:27  tina
 for OS independancy.
    
 ********************************************************************/

#ifndef VSOCK_H
#define VSOCK_H

#ifdef __vxworks
#include <resolvLib.h>
#include "sockLib.h"
#include "hostLib.h"
#include "netinet/ppp/random.h"  
#include <taskLib.h>
#include <sys/times.h>
#include <u_Lib.h>
#include <in.h>
#include <sysLib.h>
#include <bootLib.h>
#include <ctype.h>

struct ip_mreqn
{
    struct in_addr imr_multiaddr;       /* IP multicast address of group */
    struct in_addr imr_address;         /* local IP address of interface */
    int imr_ifindex;                    /* Interface index */
};

typedef int socklen_t;

#define h_errno 0

extern struct hostent* gethostbyname( const char* name );
extern struct hostent* gethostbyaddr( const char* addr, int len, int type );
extern unsigned int getpid( void );
extern int strcasecmp(const char* s1, const char* s2);
extern int strncasecmp(const char* s1, const char* s2, size_t n);

#else   

#include <netdb.h>
#include <sys/socket.h>
#include <stdlib.h>
#include <sys/time.h>
#include <pwd.h>
#include <unistd.h>
#include <sys/types.h>
#include <string.h>


#endif  // !__vxworks

extern char* getUser( void );

#endif  // VSOCK_H



