/*********************************************************************

 $Id: vtypes.h,v 1.12 2000/04/10 00:07:07 sunitha Exp $

 *********************************************************************

  This library is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.  In addition to the
  terms and conditions set forth in the GNU Lesser General Public
  License, as a condition of using this library you are required to
  grant to all users of this library or any implementation utilizing
  or derived from this library a reciprocal, no cost, worldwide,
  perpetual, non-exclusive, non-transferable, unrestricted license to
  your claims of all patents and patent applications throughout the
  world that are infringed by the library or any implementation
  utilizing or derived from this library.  In the event you
  redistribute this library or any implementation utilizing or derived
  from this library, you must prominently display the foregoing terms
  and conditions with the library or the implementation utilizing or
  derived from this library.

  In the event of a conflict of terms between the foregoing license
  grant and the terms set forth in the GNU Lesser General Public
  License, the foregoing terms and conditions shall be deemed to
  govern.

  This library is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not; write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA.

  Copyright 1999-2000 Vovida Networks, Inc.  All Rights Reserved.

 *********************************************************************

 $Log: vtypes.h,v $
 Revision 1.12  2000/04/10 00:07:07  sunitha
 moved UWORD32 outside of #ifndef u_int32_t

 Revision 1.11  2000/03/22 23:41:11  jeff
 added support for compiling on Sun Solaris

 Revision 1.10  2000/02/18 00:11:44  wenqing
 add define for sunos(__svr4__)

 Revision 1.9  2000/02/15 00:21:32  sunitha
 added support for UWORD32 for md5

 Revision 1.8  2000/02/02 01:54:58  hong
 Replacing MGCP stack's own UDP implementation with the UDP stack in util

 Revision 1.7  2000/01/11 00:56:01  bogawa
 copyright notice fixes for year 2000

 Revision 1.6  1999/12/24 02:20:33  tina
 Added consistent cvs header and LGPL license info.

    
 ********************************************************************/

#ifndef VTYPES_H_
#define VTYPES_H_

#ifdef __vxworks
/* define various types for Vovida software */
#include <time.h>
#include <sys/times.h>

#include "types/vxTypesOld.h"

#ifndef u_int32_t
typedef UINT32  u_int32_t;
#endif

#ifndef UWORD32
typedef UINT32 UWORD32;
#endif

#ifndef u_int16_t
typedef UINT16  u_int16_t;
#endif

#ifndef u_int8_t
typedef UINT8  u_int8_t;
#endif

#else
    
#ifdef __sparc
#include <inttypes.h>

//typedef unsigned char u_int8_t;
typedef uint8_t u_int8_t;
typedef uint16_t u_int16_t;
typedef uint32_t u_int32_t;
    
#else

#ifdef __svr4__
#include <pthread.h>

#ifndef u_int32_t
typedef uint32_t u_int32_t;
#endif

#ifndef u_int8_t
typedef uint8_t u_int8_t;
#endif


#else
#include <sys/types.h>
#endif

#endif

#endif
    
#endif
